package com.sun.jersey.samples.helloworld;

import com.sun.jersey.api.core.ResourceConfig;
import com.sun.jersey.spi.container.ContainerListener;
import com.sun.jersey.spi.container.ContainerNotifier;
import com.sun.jersey.spi.container.WebApplication;
import com.sun.jersey.spi.container.servlet.ServletContainer;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.ServletConfig;

/**
 *
 * @author japod
 */
public class ReloadServletContainer extends ServletContainer {

    public static class Reloader implements ContainerNotifier {

        List<ContainerListener> ls;

        public Reloader() {
            ls = new ArrayList<ContainerListener>();
        }

        @Override
        public void addListener(ContainerListener l) {
            ls.add(l);
        }

        public void reload() {
            for (ContainerListener l : ls) {
                l.onReload();
            }
        }
    }

    @Override
    protected void configure(final ServletConfig sc, ResourceConfig rc, WebApplication wa) {
        super.configure(sc, rc, wa);

        WebAppContextListener.rc = rc;

        rc.getProperties().put(ResourceConfig.PROPERTY_CONTAINER_NOTIFIER, WebAppContextListener.reloader);
    }
}
