
package com.sun.jersey.samples.singleresbundle;

import java.util.HashMap;
import java.util.logging.Logger;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.event.Event;
import org.osgi.service.event.EventAdmin;

public class Activator implements BundleActivator {

    private BundleContext bc;

    @Override
    public synchronized void start(BundleContext bundleContext) throws Exception {
        this.bc = bundleContext;

        sendAdminEvent("add", DynamicResource.class.getName());
    }


    @Override
    public synchronized void stop(BundleContext bundleContext) throws Exception {
        sendAdminEvent("remove", DynamicResource.class.getName());
    }


    private void sendAdminEvent(final String action, final String classname) {
        ServiceReference eaRef = bc.getServiceReference(EventAdmin.class.getName());
        if (eaRef != null) {
            EventAdmin ea = (EventAdmin) bc.getService(eaRef);
            ea.sendEvent(new Event("jersey/new/Resource", new HashMap<String, String>() {

                {
                    put("action", action);
                    put("resource", classname);
                }
            }));
            bc.ungetService(eaRef);
        }
    }

}
